﻿package com.wastedpotential {
	import flash.display.MovieClip;
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import net.badimon.five3D.display.Scene3D;
    import net.badimon.five3D.display.Sprite3D;
    import net.badimon.five3D.display.MovieClip3D;
	
    public class Five3DTest extends MovieClip {
		
		private var scene:Scene3D;
		private var container:Sprite3D;
		private var clip3d:MovieClip3D;
		private var isPlaying:Boolean;
		
		//- CONSTRUCTOR 
		public function Five3DTest() {
			//trace("Five3DTest :: CONSTRUCTOR");			
			scene = new Scene3D();
			scene.x = Math.round(stage.stageWidth/2);
			scene.y = Math.round(stage.stageHeight/2);
			this.addChild(scene);
			
			//create container to hold all 3D objects:
			container = new Sprite3D(); //it's always a good idea to create a container in case you need it later
			//force z-sorting if you need it (z-sort default is according to the order of the addChild calls, just like regular MovieClips):
			//we don't need it in this sample because there is only one 3D object:
			//container.childrenSorted = true; 
			scene.addChild(container);
			
			clip3d = new MovieClip3D(new testClip()); //use library class name to associate clip
			clip3d.activate(); //IMPORTANT!!! The clip will not appear on stage without this!!!
			clip3d.stop(); //don't let it play yet
			isPlaying = false;
			container.addChild(clip3d); 
			
			//add start/stop button functionality:
			this.addEventListener(Event.ENTER_FRAME, onFrame);
			startStopBu_mc.addEventListener(MouseEvent.CLICK, onClick);
			startStopBu_mc.buttonMode = true;
			startStopBu_mc.mouseChildren = false;
		} 					
		
		//-start/stop button handler:
		private function onClick(e:MouseEvent):void {
			//trace("Five3DTest :: onClick");			
			if (isPlaying) {
				clip3d.stop();
				isPlaying = false;
			}
			else {
				clip3d.play();
				isPlaying = true;
			}
		}
		
		//- onEnterFrame handler:
		private function onFrame(e:Event):void {
			//trace("Five3DTest :: onFrame");			
			container.rotationY = 0.2*(stage.mouseX - stage.stageWidth/2);
			container.rotationX = -0.2*(stage.mouseY - stage.stageHeight/2);
		}
		
	} //end class
} //end package